DOSSEG

.Model Medium

.Stack 100h

;----------------------------------------------------------------------
; Drive types and character equates.
;----------------------------------------------------------------------
DRIVE_360	EQU	1
DRIVE_1200	EQU	2
DRIVE_720	EQU	3
DRIVE_1440	EQU	4

CR		EQU	13
LF		EQU	10

;----------------------------------------------------------------------
; Static data.
;----------------------------------------------------------------------
.Data

MSG1$		DB	"Format which physical drive (0,1,etc)?$"

MSG2$		DB	CR,LF,LF,"Type 1: 360k  5.25-inch  40 tracks"
		DB	CR,LF,   "Type 2: 1.2M  5.25-inch  80 tracks"
		DB	CR,LF,   "Type 3: 720k  3.5-inch   80 tracks"
		DB	CR,LF,   "Type 4: 1.4M  3.5-inch   80 tracks"
		DB	CR,LF,   "Drive is what type?$"

MSG3$		DB	CR,LF,LF,"1 = 360k"
		DB	CR,LF,   "2 = 1.2M"
		DB	CR,LF,   "3 = 720k"
		DB	CR,LF,   "4 = 1.4M"
		DB	CR,LF,   "Format to what capacity?$"

MSG4$		DB	CR,LF,LF,"Format returned "
RESULT		DB	"xxh",CR,LF,"$"

CAPACITY	DW	360,1200,720,1440

;----------------------------------------------------------------------
; Uninitialized data.
;----------------------------------------------------------------------
.Data?

BUFFER		DB	4680 DUP (?)		;Largest buffer

;----------------------------------------------------------------------
; Executable code.
;----------------------------------------------------------------------
.Code

EXTRN		FormatDiskette$FAR:FAR

MAIN		PROC

		MOV	BX,DGROUP		;Point DS
		MOV	DS,BX			; to data segment

		MOV	ES,BX			;Point ES:DI
		MOV	DI,OFFSET BUFFER	; to buffer
;----------------------------------------------------------------------
; Solicit format details.
;----------------------------------------------------------------------
		MOV	AH,9			;Display string
		MOV	DX,OFFSET MSG1$		;Ask what drive
		INT	21H			; thru DOS

		MOV	AH,1			;Char input with echo
		INT	21H			; thru DOS

		MOV	CL,AL			;Save drive

		MOV	AH,9			;Display string
		MOV	DX,OFFSET MSG2$		;Ask drive type
		INT	21H			; thru DOS

		MOV	AH,1			;Char input with echo
		INT	21H			; thru DOS

		MOV	CH,AL			;Save type

		MOV	AH,9			;Display string
		MOV	DX,OFFSET MSG3$		;Ask capacity
		INT	21H			; thru DOS

		MOV	AH,1			;Char input with echo
		INT	21H			; thru DOS

		SUB	AL,31H			;Convert to digit
		CBW				;Convert to word
		ADD	AX,AX			;Double for indexing

		MOV	BX,AX			;Put in base register
		MOV	AX,[CAPACITY][BX]	;Then put capacity code
		XCHG	AX,CX			; in CX

		SUB	AX,3030H		;Convert to numbers
		MOV	DX,AX			;Put into DX

		CALL	FormatDiskette$FAR	;Format a diskette
;----------------------------------------------------------------------
; Convert the return code to ASCII and display.
;----------------------------------------------------------------------
		MOV	CL,4			;Shift count
		MOV	CH,30H			;ASCII blank

		MOV	AH,AL			;Save number

		SHR	AL,CL			;Get high-order digit
		CMP	AL,0AH			;0-9 or A-F?
		JB	M_1

		ADD	AL,7			;Offset for A-F
M_1:
		ADD	AL,CH			;Make ASCII

		AND	AH,0FH			;Get low-order digit
		CMP	AH,0AH			;0-9 or A-F?
		JB	M_2

		ADD	AH,7			;Offset for A-F
M_2:
		ADD	AH,CH			;Make ASCII

		MOV	WORD PTR [RESULT],AX	;Put into message

		MOV	AH,9			;Display string
		MOV	DX,OFFSET MSG4$		;Report result
		INT	21H			; thru DOS

		MOV	AH,4CH			;Terminate program
		INT	21H			; thru DOS

MAIN		ENDP
		END	MAIN
